Up

# NSWindow

### Authors

Scott Christley (`scottc@net-community.com`)
Felipe A. Rodriguez (`far@ix.netcom.com`)
Richard Frith-Macdonald (`richard@brainstorm.co.uk`)

> The window class

Copyright: (C) 1996 Free Software Foundation, Inc.

### Contents -

1. NSWindow
2. Software documentation for the NSObject(NSWindowDelegate) informal protocol
3. Software documentation for the NSWindow(GNUstepBackend) category
4. Software documentation for the NSWindow(GNUstepTextView) category

# NSWindow

Instances of the NSWindow class handle on-screen windows, their associated NSViews, and events generate by the user. An NSWindow's size is defined by its frame rectangle, which encompasses its entire structure, and its content rectangle, which includes only the content.

Every NSWindow has a content view, the NSView which forms the root of the window's view hierarchy. This view can be set using the `setContentView:` method, and accessed through the `contentView` method. `setContentView:` replaces the default content view created by NSWindow.

Other views may be added to the window by using the content view's `addSubview:` method. These subviews can also have subviews added, forming a tree structure, the view hierarchy. When an NSWindow must display itself, it causes this hierarchy to draw itself. Leaf nodes in the view hierarchy are drawn last, causing them to potentially obscure views further up in the hierarchy.

A delegate can be specified for an NSWindow, which will receive notifications of events pertaining to the window. The delegate is set using `setDelegate:`, and can be retrieved using `delegate`. The delegate can restrain resizing by implementing the `windowWillResize: toSize:` method, or control the closing of the window by implementing `windowShouldClose:`.

## NSWindow : NSResponder

> Declared in:
>   AppKit/NSWindow.h

> Conforms to:
>   NSCoding

Availability: OpenStep
Description forthcoming.

Instance Variables
Method summary

- -_captureMouse:
- -_initDefaults
- -_releaseMouse:
- -_setVisible:
- -_futureFirstResponder
- +contentRectForFrameRect:styleMask:
- +defaultDepthLimit
- +frameRectForContentRect:styleMask:
- +frameRectForScreenRect:styleMask:
- +menuChanged:
- +minFrameWidthWithTitle:styleMask:
- +removeFrameUsingName:
- +screenRectForFrameRect:styleMask:
- -acceptsMouseMovedEvents
- -alphaValue
- -animationResizeTime:
- -areCursorRectsEnabled
- -aspectRatio
- -backgroundColor
- -backingType
- -becomeKeyWindow
- -becomeMainWindow
- -cacheImageInRect:
- -canBecomeKeyWindow
- -canBecomeMainWindow
- -canHide
- -canStoreColor
- -cascadeTopLeftFromPoint:
- -center
- -close
- -constrainFrameRect:toScreen:
- -contentView
- -convertBaseToScreen:
- -convertScreenToBase:
- -counterpart
- -currentEvent
- -dataWithEPSInsideRect:
- -dataWithPDFInsideRect:
- -deepestScreen
- -defaultButtonCell
- -delegate
- -deminiaturize:
- -depthLimit
- -deviceDescription
- -disableCursorRects
- -disableFlushWindow
- -disableKeyEquivalentForDefaultButtonCell
- -discardCachedImage
- -discardCursorRects
- -discardEventsMatchingMask:beforeEvent:
- -display
- -displayIfNeeded
- -dragImage:at:offset:event:pasteboard:source:slideBack:
- -drawers
- -enableCursorRects
- -enableFlushWindow
- -enableKeyEquivalentForDefaultButtonCell
- -endEditingFor:
- -fax:
- -fieldEditor:forObject:
- -firstResponder
- -flushWindow
- -flushWindowIfNeeded
- -frame
- -frameAutosaveName
- -gState
- -hasDynamicDepthLimit
- -hasShadow
- -hidesOnDeactivate
- -initWithContentRect:styleMask:backing:defer:
- -initWithContentRect:styleMask:backing:defer:screen:
- -initWithWindowRef:
- -initialFirstResponder
- -invalidateCursorRectsForView:
- -isAutodisplay
- -isDocumentEdited
- -isExcludedFromWindowsMenu
- -isFlushWindowDisabled
- -isKeyWindow
- -isMainWindow
- -isMiniaturized
- -isOneShot
- -isOpaque
- -isReleasedWhenClosed
- -isVisible
- -keyDown:
- -keyViewSelectionDirection
- -level
- -makeFirstResponder:
- -makeKeyAndOrderFront:
- -makeKeyWindow
- -makeMainWindow
- -maxSize
- -minSize
- -miniaturize:
- -miniwindowImage
- -miniwindowTitle
- -mouseLocationOutsideOfEventStream
- -nextEventMatchingMask:
- -nextEventMatchingMask:untilDate:inMode:dequeue:
- -orderBack:
- -orderFront:
- -orderFrontRegardless
- -orderOut:
- -orderWindow:relativeTo:
- -performClose:
- -performMiniaturize:
- -performZoom:
- -postEvent:atStart:
- -print:
- -registerForDraggedTypes:
- -representedFilename
- -resetCursorRects
- -resignKeyWindow
- -resignMainWindow
- -resizeFlags
- -resizeIncrements
- -restoreCachedImage
- -saveFrameUsingName:
- -screen
- -selectKeyViewFollowingView:
- -selectKeyViewPrecedingView:
- -selectNextKeyView:
- -selectPreviousKeyView:
- -sendEvent:
- -setAcceptsMouseMovedEvents:
- -setAlphaValue:
- -setAspectRatio:
- -setAutodisplay:
- -setBackgroundColor:
- -setBackingType:
- -setCanHide:
- -setContentSize:
- -setContentView:
- -setDefaultButtonCell:
- -setDelegate:
- -setDepthLimit:
- -setDocumentEdited:
- -setDynamicDepthLimit:
- -setExcludedFromWindowsMenu:
- -setFrame:display:
- -setFrame:display:animate:
- -setFrameAutosaveName:
- -setFrameFromString:
- -setFrameOrigin:
- -setFrameTopLeftPoint:
- -setFrameUsingName:
- -setFrameUsingName:force:
- -setHasShadow:
- -setHidesOnDeactivate:
- -setInitialFirstResponder:
- -setLevel:
- -setMaxSize:
- -setMinSize:
- -setMiniwindowImage:
- -setMiniwindowTitle:
- -setOneShot:
- -setOpaque:
- -setReleasedWhenClosed:
- -setRepresentedFilename:
- -setResizeIncrements:
- -setShowsResizeIndicator:
- -setTitle:
- -setTitleWithRepresentedFilename:
- -setViewsNeedDisplay:
- -setWindowController:
- -showsResizeIndicator
- -stringWithSavedFrame
- -styleMask
- -title
- -tryToPerform:with:
- -unregisterDraggedTypes
- -update
- -useOptimizedDrawing:
- -validRequestorForSendType:returnType:
- -viewsNeedDisplay
- -windowController
- -windowHandle
- -windowNumber
- -windowRef
- -worksWhenModal
- -zoom:

### contentRectForFrameRect: styleMask:

+ (NSRect) contentRectForFrameRect: (NSRect)aRect styleMask: (unsigned int)aStyle;
Availability: OpenStep
Description forthcoming.

### defaultDepthLimit

+ (NSWindowDepth) defaultDepthLimit;
Availability: OpenStep
Description forthcoming.

### frameRectForContentRect: styleMask:

+ (NSRect) frameRectForContentRect: (NSRect)aRect styleMask: (unsigned int)aStyle;
Availability: OpenStep
Description forthcoming.

### frameRectForScreenRect: styleMask:

+ (NSRect) frameRectForScreenRect: (NSRect)aRect styleMask: (unsigned int)aStyle;
Availability: OpenStep
Description forthcoming.

### menuChanged:

+ (void) menuChanged: (NSMenu*)aMenu;
Availability: MacOS-X 10.0.0
Description forthcoming.

### minFrameWidthWithTitle: styleMask:

+ (float) minFrameWidthWithTitle: (NSString*)aTitle styleMask: (unsigned int)aStyle;
Availability: OpenStep
Description forthcoming.

### removeFrameUsingName:

+ (void) removeFrameUsingName: (NSString*)name;
Availability: OpenStep
Description forthcoming.

### screenRectForFrameRect: styleMask:

+ (NSRect) screenRectForFrameRect: (NSRect)aRect styleMask: (unsigned int)aStyle;
Availability: OpenStep
Description forthcoming.

### acceptsMouseMovedEvents

- (BOOL) acceptsMouseMovedEvents;
Availability: OpenStep
Description forthcoming.

### alphaValue

- (float) alphaValue;
Availability: MacOS-X 10.0.0
Description forthcoming.

### animationResizeTime:

- (NSTimeInterval) animationResizeTime: (NSRect)newFrame;
Availability: MacOS-X 10.0.0
Description forthcoming.

### areCursorRectsEnabled

- (BOOL) areCursorRectsEnabled;
Availability: OpenStep
Description forthcoming.

### aspectRatio

- (NSSize) aspectRatio;
Availability: MacOS-X 10.0.0
Description forthcoming.

### backgroundColor

- (NSColor*) backgroundColor;
Availability: OpenStep
Description forthcoming.

### backingType

- (NSBackingStoreType) backingType;
Availability: OpenStep
Description forthcoming.

### becomeKeyWindow

- (void) becomeKeyWindow;
Availability: OpenStep
Description forthcoming.

### becomeMainWindow

- (void) becomeMainWindow;
Availability: OpenStep
Description forthcoming.

### cacheImageInRect:

- (void) cacheImageInRect: (NSRect)aRect;
Availability: MacOS-X 10.0.0
Description forthcoming.

### canBecomeKeyWindow

- (BOOL) canBecomeKeyWindow;
Availability: OpenStep
Returns `YES` if the receiver can be made key. If this method returns `NO`, the window will not be made key. This implementation returns `YES` if the window is resizable or has a title bar. You can override this method to change it's behavior

### canBecomeMainWindow

- (BOOL) canBecomeMainWindow;
Availability: OpenStep
Returns `YES` if the receiver can be the main window. If this method returns `NO`, the window will not become the main window. This implementation returns `YES` if the window is resizable or has a title bar and is visible and is not an NSPanel. You can override this method to change it's behavior

### canHide

- (BOOL) canHide;
Availability: MacOS-X 10.0.0
Description forthcoming.

### canStoreColor

- (BOOL) canStoreColor;
Availability: OpenStep
Description forthcoming.

### cascadeTopLeftFromPoint:

- (NSPoint) cascadeTopLeftFromPoint: (NSPoint)topLeftPoint;
Availability: OpenStep
Description forthcoming.

### center

- (void) center;
Availability: OpenStep
Description forthcoming.

### close

- (void) close;
Availability: OpenStep
Description forthcoming.

### constrainFrameRect: toScreen:

- (NSRect) constrainFrameRect: (NSRect)frameRect toScreen: (NSScreen*)screen;
Availability: OpenStep
Given a proposed frame rectangle, return a modified version which will fit inside the screen .

### contentView

- (id) contentView;
Availability: OpenStep
Description forthcoming.

### convertBaseToScreen:

- (NSPoint) convertBaseToScreen: (NSPoint)aPoint;
Availability: OpenStep
Convert from a point in the base coordinate system for the window to a point in the screen coordinate system.

### convertScreenToBase:

- (NSPoint) convertScreenToBase: (NSPoint)aPoint;
Availability: OpenStep
Convert from a point in the screen coordinate system to a point in the screen coordinate system of the receiver.

### counterpart

- (NSWindow*) counterpart;
Availability: Gui
Description forthcoming.

### currentEvent

- (NSEvent*) currentEvent;
Availability: OpenStep
Description forthcoming.

### dataWithEPSInsideRect:

- (NSData*) dataWithEPSInsideRect: (NSRect)rect;
Availability: OpenStep
Description forthcoming.

### dataWithPDFInsideRect:

- (NSData*) dataWithPDFInsideRect: (NSRect)aRect;
Availability: MacOS-X 10.0.0
Description forthcoming.

### deepestScreen

- (NSScreen*) deepestScreen;
Availability: OpenStep
Returns the screen the window is on. Unlike (apparently) OpenStep and MacOSX, GNUstep does not support windows being split across multiple screens

### defaultButtonCell

- (NSButtonCell*) defaultButtonCell;
Availability: MacOS-X 10.0.0
Description forthcoming.

### delegate

- (id) delegate;
Availability: OpenStep
Description forthcoming.

### deminiaturize:

- (void) deminiaturize: (id)sender;
Availability: OpenStep
Causes the window to deminiaturize. Normally you would not call this method directly. A window is automatically deminiaturized by the user via a mouse click event. Does nothing it the window isn't miniaturized.

### depthLimit

- (NSWindowDepth) depthLimit;
Availability: OpenStep
Description forthcoming.

### deviceDescription

- (NSDictionary*) deviceDescription;
Availability: OpenStep
Description forthcoming.

### disableCursorRects

- (void) disableCursorRects;
Availability: OpenStep
Description forthcoming.

### disableFlushWindow

- (void) disableFlushWindow;
Availability: OpenStep
Description forthcoming.

### disableKeyEquivalentForDefaultButtonCell

- (void) disableKeyEquivalentForDefaultButtonCell;
Availability: MacOS-X 10.0.0
Description forthcoming.

### discardCachedImage

- (void) discardCachedImage;
Availability: MacOS-X 10.0.0
Description forthcoming.

### discardCursorRects

- (void) discardCursorRects;
Availability: OpenStep
Description forthcoming.

### discardEventsMatchingMask: beforeEvent:

- (void) discardEventsMatchingMask: (unsigned int)mask beforeEvent: (NSEvent*)lastEvent;
Availability: OpenStep
Description forthcoming.

### display

- (void) display;
Availability: OpenStep
Description forthcoming.

### displayIfNeeded

- (void) displayIfNeeded;
Availability: OpenStep
Description forthcoming.

### dragImage: at: offset: event: pasteboard: source: slideBack:

- (void) dragImage: (NSImage*)anImage at: (NSPoint)baseLocation offset: (NSSize)initialOffset event: (NSEvent*)event pasteboard: (NSPasteboard*)pboard source: (id)sourceObject slideBack: (BOOL)slideFlag;
Availability: OpenStep
Description forthcoming.

### drawers

- (NSArray*) drawers;
Availability: MacOS-X 10.0.0
Description forthcoming.

### enableCursorRects

- (void) enableCursorRects;
Availability: OpenStep
Description forthcoming.

### enableFlushWindow

- (void) enableFlushWindow;
Availability: OpenStep
Description forthcoming.

### enableKeyEquivalentForDefaultButtonCell

- (void) enableKeyEquivalentForDefaultButtonCell;
Availability: MacOS-X 10.0.0
Description forthcoming.

### endEditingFor:

- (void) endEditingFor: (id)anObject;
Availability: OpenStep
Description forthcoming.

### fax:

- (void) fax: (id)sender;
Availability: OpenStep
Description forthcoming.

### fieldEditor: forObject:

- (NSText*) fieldEditor: (BOOL)createFlag forObject: (id)anObject;
Availability: OpenStep
Description forthcoming.

### firstResponder

- (NSResponder*) firstResponder;
Availability: OpenStep
Description forthcoming.

### flushWindow

- (void) flushWindow;
Availability: OpenStep
Flush all drawing in the windows buffer to the screen unless the window is not buffered or flushing is not enabled.

### flushWindowIfNeeded

- (void) flushWindowIfNeeded;
Availability: OpenStep
Description forthcoming.

### frame

- (NSRect) frame;
Availability: OpenStep
Description forthcoming.

### frameAutosaveName

- (NSString*) frameAutosaveName;
Availability: OpenStep
Description forthcoming.

### gState

- (int) gState;
Availability: OpenStep
Description forthcoming.

### hasDynamicDepthLimit

- (BOOL) hasDynamicDepthLimit;
Availability: OpenStep
Description forthcoming.

### hasShadow

- (BOOL) hasShadow;
Availability: MacOS-X 10.0.0
Description forthcoming.

### hidesOnDeactivate

- (BOOL) hidesOnDeactivate;
Availability: OpenStep
Description forthcoming.

### initWithContentRect: styleMask: backing: defer:

- (id) initWithContentRect: (NSRect)contentRect styleMask: (unsigned int)aStyle backing: (NSBackingStoreType)bufferingType defer: (BOOL)flag;
Availability: OpenStep

Initializes the receiver with a content rect of contentRect, a style mask of styleMask, and a backing store type of backingType.

The style mask values are `NSTitledWindowMask`, for a window with a title, `NSClosableWindowMask`, for a window with a close widget, `NSMiniaturizableWindowMask`, for a window with a miniaturize widget, and `NSResizableWindowMask`, for a window with a resizing widget. These mask values can be OR'd in any combination.

Backing store values are `NSBackingStoreBuffered`, `NSBackingStoreRetained` and `NSBackingStoreNonretained`.

### initWithContentRect: styleMask: backing: defer: screen:

- (id) initWithContentRect: (NSRect)contentRect styleMask: (unsigned int)aStyle backing: (NSBackingStoreType)bufferingType defer: (BOOL)flag screen: (NSScreen*)aScreen;
Availability: OpenStep

Initializes the receiver with a content rect of contentRect, a style mask of styleMask, a backing store type of backingType and a boolean flag. flag specifies whether the window should be created now (`NO`), or when it is displayed (`YES`).

The style mask values are `NSTitledWindowMask`, for a window with a title, `NSClosableWindowMask`, for a window with a close widget, `NSMiniaturizableWindowMask`, for a window with a miniaturize widget, and `NSResizableWindowMask`, for a window with a resizing widget. These mask values can be OR'd in any combination.

Backing store values are `NSBackingStoreBuffered`, `NSBackingStoreRetained` and `NSBackingStoreNonretained`.

### initWithWindowRef:

- (id) initWithWindowRef: (void*)windowRef;
Availability: MacOS-X 10.0.0
Description forthcoming.

### initialFirstResponder

- (NSView*) initialFirstResponder;
Availability: MacOS-X 10.0.0
Description forthcoming.

### invalidateCursorRectsForView:

- (void) invalidateCursorRectsForView: (NSView*)aView;
Availability: OpenStep
Description forthcoming.

### isAutodisplay

- (BOOL) isAutodisplay;
Availability: OpenStep
Description forthcoming.

### isDocumentEdited

- (BOOL) isDocumentEdited;
Availability: OpenStep
Description forthcoming.

### isExcludedFromWindowsMenu

- (BOOL) isExcludedFromWindowsMenu;
Availability: OpenStep
Description forthcoming.

### isFlushWindowDisabled

- (BOOL) isFlushWindowDisabled;
Availability: OpenStep
Description forthcoming.

### isKeyWindow

- (BOOL) isKeyWindow;
Availability: OpenStep
Description forthcoming.

### isMainWindow

- (BOOL) isMainWindow;
Availability: OpenStep
Description forthcoming.

### isMiniaturized

- (BOOL) isMiniaturized;
Availability: OpenStep
Description forthcoming.

### isOneShot

- (BOOL) isOneShot;
Availability: OpenStep
Description forthcoming.

### isOpaque

- (BOOL) isOpaque;
Availability: MacOS-X 10.0.0
Description forthcoming.

### isReleasedWhenClosed

- (BOOL) isReleasedWhenClosed;
Availability: OpenStep
Description forthcoming.

### isVisible

- (BOOL) isVisible;
Availability: OpenStep
Description forthcoming.

### keyDown:

- (void) keyDown: (NSEvent*)theEvent;
Availability: OpenStep
Description forthcoming.

### keyViewSelectionDirection

- (NSSelectionDirection) keyViewSelectionDirection;
Availability: MacOS-X 10.0.0
Description forthcoming.

### level

- (int) level;
Availability: OpenStep
Description forthcoming.

### makeFirstResponder:

- (BOOL) makeFirstResponder: (NSResponder*)aResponder;
Availability: OpenStep
This method attempts to make aResponder the first responder.
If aResponder is already the first responder, this method has no effect and simply returns `YES`. Otherwise, the method sends a -resignFirstResponder message to the current first responder (if there is one) and immediately returns `NO` if the current first responder refuses to resign.
Then the method asks aResponder to become first responder by sending it a -becomeFirstResponder message, and if that returns `YES` then this method immediately returns `YES`.
However, if that returns `NO`, the receiver is made the first responder by sending it a -becomeFirstResponder message, and this method returns `NO`.
If aResponder is neither `nil` nor an instance of NSResponder (or of a subclass of NSResponder) then behavior is undefined (though the current GNUstep implementation just returns `NO`).

### makeKeyAndOrderFront:

- (void) makeKeyAndOrderFront: (id)sender;
Availability: OpenStep
Description forthcoming.

### makeKeyWindow

- (void) makeKeyWindow;
Availability: OpenStep
Description forthcoming.

### makeMainWindow

- (void) makeMainWindow;
Availability: OpenStep
Description forthcoming.

### maxSize

- (NSSize) maxSize;
Availability: OpenStep
Description forthcoming.

### minSize

- (NSSize) minSize;
Availability: OpenStep
Description forthcoming.

### miniaturize:

- (void) miniaturize: (id)sender;
Availability: OpenStep
Causes the window to miniaturize, that is the window is removed from the screen and it's counterpart (mini)window is displayed. Does nothing if the window can't be miniaturized (eg. because it's already miniaturized).

### miniwindowImage

- (NSImage*) miniwindowImage;
Availability: OpenStep
Description forthcoming.

### miniwindowTitle

- (NSString*) miniwindowTitle;
Availability: OpenStep
Description forthcoming.

### mouseLocationOutsideOfEventStream

- (NSPoint) mouseLocationOutsideOfEventStream;
Availability: OpenStep
Description forthcoming.

### nextEventMatchingMask:

- (NSEvent*) nextEventMatchingMask: (unsigned int)mask;
Availability: OpenStep
Description forthcoming.

### nextEventMatchingMask: untilDate: inMode: dequeue:

- (NSEvent*) nextEventMatchingMask: (unsigned int)mask untilDate: (NSDate*)expiration inMode: (NSString*)mode dequeue: (BOOL)deqFlag;
Availability: OpenStep
Description forthcoming.

### orderBack:

- (void) orderBack: (id)sender;
Availability: OpenStep
Orders the window to the back of its level. Equivalent to -orderWindow: NSWindowBelow relativeTo: 0.

### orderFront:

- (void) orderFront: (id)sender;
Availability: OpenStep
If the application is active, orders the window to the front in its level. If the application is not active, the window is ordered in as far forward as possible in its level without being ordered in front of the key or main window of the currently active app. The current key and main window status is not changed. Equivalent to -orderWindow: NSWindowAbove relativeTo: 0.

### orderFrontRegardless

- (void) orderFrontRegardless;
Availability: OpenStep
Orders the window to the front in its level (even in front of the key and main windows of the current app) regardless of whether the app is current or not. This method should only be used in rare cases where the app is cooperating with another app that is displaying data for it. The current key and main window status is not changed.

### orderOut:

- (void) orderOut: (id)sender;
Availability: OpenStep
Orders the window out from the screen. Equivalent to -orderWindow: NSWindowOut relativeTo: 0.

### orderWindow: relativeTo:

- (void) orderWindow: (NSWindowOrderingMode)place relativeTo: (int)otherWin;
Availability: OpenStep

If place is NSWindowOut, removes the window from the screen. If place is NSWindowAbove, places the window directly above otherWin, or directly above all windows in its level if otherWin is 0. If place is NSWindowBelow, places the window directly below otherWin, or directly below all windows in its level if otherWin is 0.

If place is NSWindowAbove or NSWindowBelow and the application is hidden, the application is unhidden.

### performClose:

- (void) performClose: (id)sender;
Availability: OpenStep
Description forthcoming.

### performMiniaturize:

- (void) performMiniaturize: (id)sender;
Availability: OpenStep
Miniaturize the receiver... as long as its style mask includes NSMiniaturizableWindowMask (and as long as the receiver is not an icon or mini window itsself). Calls -miniaturize: to do this.
Beeps if the window can't be miniaturised.
Should ideally provide visual feedback (highlighting the miniaturize button as if it had been clicked) first... but that's not yet implemented.

### performZoom:

- (void) performZoom: (id)sender;
Availability: MacOS-X 10.0.0
Description forthcoming.

### postEvent: atStart:

- (void) postEvent: (NSEvent*)event atStart: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### print:

- (void) print: (id)sender;
Availability: OpenStep
Description forthcoming.

### registerForDraggedTypes:

- (void) registerForDraggedTypes: (NSArray*)newTypes;
Availability: OpenStep
Description forthcoming.

### representedFilename

- (NSString*) representedFilename;
Availability: OpenStep
Description forthcoming.

### resetCursorRects

- (void) resetCursorRects;
Availability: OpenStep
Description forthcoming.

### resignKeyWindow

- (void) resignKeyWindow;
Availability: OpenStep
Description forthcoming.

### resignMainWindow

- (void) resignMainWindow;
Availability: OpenStep
Description forthcoming.

### resizeFlags

- (int) resizeFlags;
Availability: OpenStep
Description forthcoming.

### resizeIncrements

- (NSSize) resizeIncrements;
Availability: MacOS-X 10.0.0
Description forthcoming.

### restoreCachedImage

- (void) restoreCachedImage;
Availability: MacOS-X 10.0.0
Description forthcoming.

### saveFrameUsingName:

- (void) saveFrameUsingName: (NSString*)name;
Availability: OpenStep
Description forthcoming.

### screen

- (NSScreen*) screen;
Availability: OpenStep
Returns the screen the window is on.

### selectKeyViewFollowingView:

- (void) selectKeyViewFollowingView: (NSView*)aView;
Availability: MacOS-X 10.0.0
Description forthcoming.

### selectKeyViewPrecedingView:

- (void) selectKeyViewPrecedingView: (NSView*)aView;
Availability: MacOS-X 10.0.0
Description forthcoming.

### selectNextKeyView:

- (void) selectNextKeyView: (id)sender;
Availability: MacOS-X 10.0.0
Description forthcoming.

### selectPreviousKeyView:

- (void) selectPreviousKeyView: (id)sender;
Availability: MacOS-X 10.0.0
Description forthcoming.

### sendEvent:

- (void) sendEvent: (NSEvent*)theEvent;
Availability: OpenStep
Handles mouse and other events sent to the receiver by NSApplication. Do not invoke this method directly.

### setAcceptsMouseMovedEvents:

- (void) setAcceptsMouseMovedEvents: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setAlphaValue:

- (void) setAlphaValue: (float)windowAlpha;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setAspectRatio:

- (void) setAspectRatio: (NSSize)ratio;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setAutodisplay:

- (void) setAutodisplay: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setBackgroundColor:

- (void) setBackgroundColor: (NSColor*)color;
Availability: OpenStep
Description forthcoming.

### setBackingType:

- (void) setBackingType: (NSBackingStoreType)type;
Availability: OpenStep
Description forthcoming.

### setCanHide:

- (void) setCanHide: (BOOL)flag;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setContentSize:

- (void) setContentSize: (NSSize)aSize;
Availability: OpenStep
Description forthcoming.

### setContentView:

- (void) setContentView: (NSView*)aView;
Availability: OpenStep
Sets the window's content view to aView, replacing any previous content view.

### setDefaultButtonCell:

- (void) setDefaultButtonCell: (NSButtonCell*)aCell;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setDelegate:

- (void) setDelegate: (id)anObject;
Availability: OpenStep
Description forthcoming.

### setDepthLimit:

- (void) setDepthLimit: (NSWindowDepth)limit;
Availability: OpenStep
Description forthcoming.

### setDocumentEdited:

- (void) setDocumentEdited: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setDynamicDepthLimit:

- (void) setDynamicDepthLimit: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setExcludedFromWindowsMenu:

- (void) setExcludedFromWindowsMenu: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setFrame: display:

- (void) setFrame: (NSRect)frameRect display: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setFrame: display: animate:

- (void) setFrame: (NSRect)frameRect display: (BOOL)displayFlag animate: (BOOL)animationFlag;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setFrameAutosaveName:

- (BOOL) setFrameAutosaveName: (NSString*)name;
Availability: OpenStep
Description forthcoming.

### setFrameFromString:

- (void) setFrameFromString: (NSString*)string;
Availability: OpenStep
Description forthcoming.

### setFrameOrigin:

- (void) setFrameOrigin: (NSPoint)aPoint;
Availability: OpenStep
Description forthcoming.

### setFrameTopLeftPoint:

- (void) setFrameTopLeftPoint: (NSPoint)aPoint;
Availability: OpenStep
Description forthcoming.

### setFrameUsingName:

- (BOOL) setFrameUsingName: (NSString*)name;
Availability: OpenStep
Description forthcoming.

### setFrameUsingName: force:

- (BOOL) setFrameUsingName: (NSString*)name force: (BOOL)force;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setHasShadow:

- (void) setHasShadow: (BOOL)hasShadow;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setHidesOnDeactivate:

- (void) setHidesOnDeactivate: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setInitialFirstResponder:

- (void) setInitialFirstResponder: (NSView*)aView;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setLevel:

- (void) setLevel: (int)newLevel;
Availability: OpenStep
Description forthcoming.

### setMaxSize:

- (void) setMaxSize: (NSSize)aSize;
Availability: OpenStep
Description forthcoming.

### setMinSize:

- (void) setMinSize: (NSSize)aSize;
Availability: OpenStep
Description forthcoming.

### setMiniwindowImage:

- (void) setMiniwindowImage: (NSImage*)image;
Availability: OpenStep
Description forthcoming.

### setMiniwindowTitle:

- (void) setMiniwindowTitle: (NSString*)title;
Availability: OpenStep
Description forthcoming.

### setOneShot:

- (void) setOneShot: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setOpaque:

- (void) setOpaque: (BOOL)isOpaque;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setReleasedWhenClosed:

- (void) setReleasedWhenClosed: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setRepresentedFilename:

- (void) setRepresentedFilename: (NSString*)aString;
Availability: OpenStep
Description forthcoming.

### setResizeIncrements:

- (void) setResizeIncrements: (NSSize)aSize;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setShowsResizeIndicator:

- (void) setShowsResizeIndicator: (BOOL)show;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setTitle:

- (void) setTitle: (NSString*)aString;
Availability: OpenStep
Sets the window's title to the string aString.

### setTitleWithRepresentedFilename:

- (void) setTitleWithRepresentedFilename: (NSString*)aString;
Availability: OpenStep
Description forthcoming.

### setViewsNeedDisplay:

- (void) setViewsNeedDisplay: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setWindowController:

- (void) setWindowController: (NSWindowController*)windowController;
Availability: OpenStep
Description forthcoming.

### showsResizeIndicator

- (BOOL) showsResizeIndicator;
Availability: MacOS-X 10.0.0
Description forthcoming.

### stringWithSavedFrame

- (NSString*) stringWithSavedFrame;
Availability: OpenStep
Description forthcoming.

### styleMask

- (unsigned int) styleMask;
Availability: OpenStep
Description forthcoming.

### title

- (NSString*) title;
Availability: OpenStep
Returns an NSString containing the text of the window's title.

### tryToPerform: with:

- (BOOL) tryToPerform: (SEL)anAction with: (id)anObject;
Availability: OpenStep
Description forthcoming.

### unregisterDraggedTypes

- (void) unregisterDraggedTypes;
Availability: OpenStep
Description forthcoming.

### update

- (void) update;
Availability: OpenStep
Description forthcoming.

### useOptimizedDrawing:

- (void) useOptimizedDrawing: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### validRequestorForSendType: returnType:

- (id) validRequestorForSendType: (NSString*)sendType returnType: (NSString*)returnType;
Availability: OpenStep
Description forthcoming.

### viewsNeedDisplay

- (BOOL) viewsNeedDisplay;
Availability: OpenStep
Description forthcoming.

### windowController

- (id) windowController;
Availability: OpenStep
Description forthcoming.

### windowHandle

- (void*) windowHandle;
Availability: MacOS-X 10.0.0
Description forthcoming.

### windowNumber

- (int) windowNumber;
Availability: OpenStep
Description forthcoming.

### windowRef

- (void*) windowRef;
Availability: MacOS-X 10.0.0
Description forthcoming.

### worksWhenModal

- (BOOL) worksWhenModal;
Availability: OpenStep
Description forthcoming.

### zoom:

- (void) zoom: (id)sender;
Availability: MacOS-X 10.0.0
Description forthcoming.

## Instance Variables for NSWindow Class

### _alphaValue

@protected float _alphaValue;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _autosaveName

@protected NSString* _autosaveName;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _backgroundColor

@protected NSColor* _backgroundColor;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _backingType

@protected NSBackingStoreType _backingType;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _cachedImage

@protected NSCachedImageRep* _cachedImage;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _cachedImageOrigin

@protected NSPoint _cachedImageOrigin;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _contentView

@protected id _contentView;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _counterpart

@protected int _counterpart;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _defaultButtonCell

@protected id _defaultButtonCell;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _delegate

@protected id _delegate;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _depthLimit

@protected NSWindowDepth _depthLimit;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _disableFlushWindow

@protected unsigned int _disableFlushWindow;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _f

@protected struct GSWindowFlagsType _f;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _fieldEditor

@protected id _fieldEditor;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _firstResponder

@protected id _firstResponder;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _frame

@protected NSRect _frame;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _futureFirstResponder

@protected id _futureFirstResponder;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _gstate

@protected int _gstate;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _increments

@protected NSSize _increments;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _initialFirstResponder

@protected NSView* _initialFirstResponder;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _lastDragOperationMask

@protected int _lastDragOperationMask;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _lastDragView

@protected id _lastDragView;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _lastPoint

@protected NSPoint _lastPoint;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _lastView

@protected id _lastView;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _maximumSize

@protected NSSize _maximumSize;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _miniaturizedImage

@protected NSImage* _miniaturizedImage;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _miniaturizedTitle

@protected NSString* _miniaturizedTitle;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _minimumSize

@protected NSSize _minimumSize;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _rectNeedingFlush

@protected NSRect _rectNeedingFlush;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _rectsBeingDrawn

@protected NSMutableArray* _rectsBeingDrawn;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _representedFilename

@protected NSString* _representedFilename;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _reserved_1

@protected void* _reserved_1;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _reserved_2

@protected void* _reserved_2;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _reserved_s

@protected void* _reserved_s;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _screen

@protected NSScreen* _screen;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _selectionDirection

@protected NSSelectionDirection _selectionDirection;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _styleMask

@protected unsigned int _styleMask;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _toolbar

@protected NSToolbar* _toolbar;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _toolbarView

@protected id _toolbarView;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _windowController

@protected NSWindowController* _windowController;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _windowLevel

@protected int _windowLevel;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _windowNum

@protected int _windowNum;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _windowTitle

@protected NSString* _windowTitle;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _wv

@protected GSWindowDecorationView* _wv;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

# Software documentation for the NSObject(NSWindowDelegate) informal protocol

## NSObject(NSWindowDelegate)

> Declared in:
>   AppKit/NSWindow.h

Availability: OpenStep
Description forthcoming.
Method summary

- -windowDidBecomeKey:
- -windowDidBecomeMain:
- -windowDidChangeScreen:
- -windowDidDeminiaturize:
- -windowDidExpose:
- -windowDidMiniaturize:
- -windowDidMove:
- -windowDidResignKey:
- -windowDidResignMain:
- -windowDidResize:
- -windowDidUpdate:
- -windowShouldClose:
- -windowShouldZoom:toFrame:
- -windowWillClose:
- -windowWillMiniaturize:
- -windowWillMove:
- -windowWillResize:toSize:
- -windowWillReturnFieldEditor:toObject:
- -windowWillUseStandardFrame:defaultFrame:

### windowDidBecomeKey:

- (void) windowDidBecomeKey: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidBecomeMain:

- (void) windowDidBecomeMain: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidChangeScreen:

- (void) windowDidChangeScreen: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidDeminiaturize:

- (void) windowDidDeminiaturize: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidExpose:

- (void) windowDidExpose: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidMiniaturize:

- (void) windowDidMiniaturize: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidMove:

- (void) windowDidMove: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidResignKey:

- (void) windowDidResignKey: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidResignMain:

- (void) windowDidResignMain: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidResize:

- (void) windowDidResize: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidUpdate:

- (void) windowDidUpdate: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowShouldClose:

- (BOOL) windowShouldClose: (id)sender;
Availability: OpenStep
Description forthcoming.

### windowShouldZoom: toFrame:

- (BOOL) windowShouldZoom: (NSWindow*)sender toFrame: (NSRect)aFrame;
Availability: MacOS-X 10.0.0
Description forthcoming.

### windowWillClose:

- (void) windowWillClose: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowWillMiniaturize:

- (void) windowWillMiniaturize: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowWillMove:

- (void) windowWillMove: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowWillResize: toSize:

- (NSSize) windowWillResize: (NSWindow*)sender toSize: (NSSize)frameSize;
Availability: OpenStep
Description forthcoming.

### windowWillReturnFieldEditor: toObject:

- (id) windowWillReturnFieldEditor: (NSWindow*)sender toObject: (id)client;
Availability: OpenStep
Description forthcoming.

### windowWillUseStandardFrame: defaultFrame:

- (NSRect) windowWillUseStandardFrame: (NSWindow*)sender defaultFrame: (NSRect)aFrame;
Availability: MacOS-X 10.0.0
Description forthcoming.

# Software documentation for the NSWindow(GNUstepBackend) category

## NSWindow(GNUstepBackend)

> Declared in:
>   AppKit/NSWindow.h

Availability: Gui
Description forthcoming.
Method summary

- -_captureMouse:
- -_initDefaults
- -_releaseMouse:
- -_setVisible:

### _captureMouse:

- (void) _captureMouse: (id)sender;
Availability: Gui
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _initDefaults

- (void) _initDefaults;
Availability: Gui
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _releaseMouse:

- (void) _releaseMouse: (id)sender;
Availability: Gui
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _setVisible:

- (void) _setVisible: (BOOL)flag;
Availability: Gui
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

# Software documentation for the NSWindow(GNUstepTextView) category

## NSWindow(GNUstepTextView)

> Declared in:
>   AppKit/NSWindow.h

Availability: Gui
Description forthcoming.
Method summary

- -_futureFirstResponder

### _futureFirstResponder

- (id) _futureFirstResponder;
Availability: Gui
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

Up